# Constraints associated with a circuit

def resistor(R):
    # assumes a list or tuple x = [vn1, vn2, iR]
    return lambda x : x[0] - x[1] - float(R)*x[2]

def vsrc(Vs):
    # assumes a list or tuple x = [vn1, vn2, iR]
    return lambda x : x[0] - x[1] - Vs

def kcl(signs):
    # Set up a sum of signed currents = 0 equation
    def kclsum(x):
        sum = 0.0
        for i in range(len(x)) :
            sum = sum + signs[i]*x[i] # Can not count on list container
        return sum
    return kclsum

def set_ground(x):
    # Enforces a constaint that variable should be zero.
    return x[0]
